Index: trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/clients/clients.cshtml
===================================================================
--- trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/clients/clients.cshtml	(revision 13397)
+++ trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/clients/clients.cshtml	(revision 14820)
@@ -33,18 +33,18 @@
                 </div>
                 <div class="panel-body">
-                    <table class="table table-hover table-condensed">
+                    <table class="table table-hover table-condensed" ts-wrapper>
                         <thead>
                         <tr>
                             <th>#</th>
-                            <th>Client Name</th>
-                            <th>Group Name</th>
-                            <th>Cores</th>
-                            <th>Cpu Utilization</th>
-                            <th>Memory</th>
-                            <th>State</th>
+                            <th ts-criteria="Name">Client Name</th>
+                            <th ts-criteria="GroupName">Group Name</th>
+                            <th ts-criteria="UsedCores">Cores</th>
+                            <th ts-criteria="CpuUtilization">Cpu Utilization</th>
+                            <th ts-criteria="UsedMemory">Memory</th>
+                            <th ts-criteria="State">State</th>
                             <th></th>
                         </tr>
                         </thead>
-                        <tr ng-repeat="client in clientPage.Clients">
+                        <tr ng-repeat="client in clientPage.Clients" ts-repeat>
                             <td>{{($index + 1)+((curClientsPage-1)*(clientsPageSize))}}</td>
                             <td>{{client.Name}}</td>
@@ -81,18 +81,18 @@
                 </div>
                 <div class="panel-body">
-                    <table class="table table-hover table-condensed">
+                    <table class="table table-hover table-condensed" ts-wrapper>
                         <thead>
                             <tr>
                                 <th>#</th>
-                                <th>Client Name</th>
-                                <th>Group Name</th>
-                                <th>Cores</th>
-                                <th>Cpu Utilization</th>
-                                <th>Memory</th>
-                                <th>State</th>
+                                <th ts-criteria="Name">Client Name</th>
+                                <th ts-criteria="GroupName">Group Name</th>
+                                <th ts-criteria="UsedCores">Cores</th>
+                                <th ts-criteria="CpuUtilization">Cpu Utilization</th>
+                                <th ts-criteria="UsedMemory">Memory</th>
+                                <th ts-criteria="State">State</th>
                                 <th></th>
                             </tr>
                         </thead>
-                        <tr ng-repeat="client in expiredClientPage.Clients">
+                        <tr ng-repeat="client in expiredClientPage.Clients" ts-repeat>
                             <td>{{($index + 1)+((curExpiredClientsPage-1)*(expiredClientsPageSize))}}</td>
                             <td>{{client.Name}}</td>
Index: trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/exceptions/exceptions.cshtml
===================================================================
--- trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/exceptions/exceptions.cshtml	(revision 13397)
+++ trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/exceptions/exceptions.cshtml	(revision 14820)
@@ -30,17 +30,17 @@
                 </div>
                 <div class="panel-body">
-                    <table class="table table-hover table-condensed">
+                    <table class="table table-hover table-condensed" ts-wrapper>
                         <thead>
                         <tr>
                             <th>#</th>
-                            <th>Job</th>
-                            <th>Task</th>
-                            <th>Username</th>
-                            <th>Client</th>
-                            <th>Date</th>
+                            <th ts-criteria="JobName">Job</th>
+                            <th ts-criteria="TaskId">Task</th>
+                            <th ts-criteria="UserName">Username</th>
+                            <th ts-criteria="ClientName">Client</th>
+                            <th ts-criteria="Date">Date</th>
                             <th></th>
                         </tr>
                         </thead>
-                        <tr ng-repeat="exception in exceptionPage.Exceptions">
+                        <tr ng-repeat="exception in exceptionPage.Exceptions" ts-repeat>
                             <td>{{($index + 1)+((curExceptionsPage-1)*(exceptionsPageSize))}}</td>
                             <td><a ng-href="#/statistics/jobs/{{exception.JobId}}">{{exception.JobName}}</a></td>
Index: trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/groups/groups.cshtml
===================================================================
--- trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/groups/groups.cshtml	(revision 13397)
+++ trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/groups/groups.cshtml	(revision 14820)
@@ -33,17 +33,17 @@
                 </div>
                 <div class="panel-body">
-                    <table class="table table-hover table-condensed">
+                    <table class="table table-hover table-condensed" ts-wrapper>
                         <thead>
                         <tr>
                             <th>#</th>
-                            <th>Group Name</th>
-                            <th>Cores</th>
-                            <th>Cpu Utilization</th>
-                            <th>Memory</th>
-                            <th>Clients</th>
+                            <th ts-criteria="Name">Group Name</th>
+                            <th ts-criteria="UsedCores">Cores</th>
+                            <th ts-criteria="CpuUtilization">Cpu Utilization</th>
+                            <th ts-criteria="UsedMemory">Memory</th>
+                            <th ts-criteria="OnlineClients">Clients</th>
                             <th></th>
                         </tr>
                         </thead>
-                        <tr ng-repeat="group in groupPage.Groups">
+                        <tr ng-repeat="group in groupPage.Groups" ts-repeat>
                             <td>{{($index + 1)+((curGroupsPage-1)*(groupsPageSize))}}</td>
                             <td>{{group.Name}}</td>
Index: trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/jobs/jobs.cshtml
===================================================================
--- trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/jobs/jobs.cshtml	(revision 13397)
+++ trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/jobs/jobs.cshtml	(revision 14820)
@@ -33,13 +33,13 @@
                 </div>
                 <div class="panel-body">
-                    <table class="table table-hover table-condensed">
+                    <table class="table table-hover table-condensed" ts-wrapper>
                         <thead>
                         <tr>
                             <th>#</th>
-                            <th>Job Name</th>
+                            <th ts-criteria="Name">Job Name</th>
                             @if (Request.IsAuthenticated && User.IsInRole(HiveRoles.Administrator)) {
-                                <th>Username</th>
+                                <th ts-criteria="UserName">Username</th>
                             }
-                            <th>Date Created</th>
+                            <th ts-criteria="DateCreated">Date Created</th>
                             <th>Progress</th>
                             <th></th>
@@ -47,5 +47,5 @@
                         </thead>
                         @if (Request.IsAuthenticated && User.IsInRole(HiveRoles.Administrator)) {
-                            <tr ng-repeat="job in allUsersJobs">
+                            <tr ng-repeat="job in allUsersJobs" ts-repeat>
                                 <td>{{$index + 1}}</td>
                                 <td>{{job.Name}}</td>
@@ -93,16 +93,16 @@
                 </div>
                 <div class="panel-body">
-                    <table class="table table-hover table-condensed">
+                    <table class="table table-hover table-condensed" ts-wrapper>
                         <thead>
                         <tr>
                             <th>#</th>
-                            <th>Job Name</th>
-                            <th>Date Created</th>
-                            <th>Date Completed</th>
-                            <th>Tasks</th>
+                            <th ts-criteria="Name">Job Name</th>
+                            <th ts-criteria="DateCreated">Date Created</th>
+                            <th ts-criteria="DateCompleted">Date Completed</th>
+                            <th ts-criteria="TotalTasks|parseInt">Tasks</th>
                             <th></th>
                         </tr>
                         </thead>
-                        <tr ng-repeat="job in completedJobPage.Jobs">
+                        <tr ng-repeat="job in completedJobPage.Jobs" ts-repeat>
                             <td>{{($index + 1)+((completedJobCurPage-1)*(completedJobPageSize))}}</td>
                             <td>{{job.Name}}</td>
Index: trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/users/users.cshtml
===================================================================
--- trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/users/users.cshtml	(revision 13397)
+++ trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/users/users.cshtml	(revision 14820)
@@ -30,13 +30,13 @@
                 </div>
                 <div class="panel-body">
-                    <table class="table table-hover table-condensed">
+                    <table class="table table-hover table-condensed" ts-wrapper>
                         <thead>
                             <tr>
                                 <th>#</th>
-                                <th>Username</th>
+                                <th ts-criteria="Name">Username</th>
                                 <th></th>
                             </tr>
                         </thead>
-                        <tr ng-repeat="user in users">
+                        <tr ng-repeat="user in users" ts-repeat>
                             <td>{{$index + 1}}</td>
                             <td>{{user.Name}}</td>