Index: branches/symbreg-factors-2650/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/CF1.cs
===================================================================
--- branches/symbreg-factors-2650/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/CF1.cs	(revision 14825)
+++ branches/symbreg-factors-2650/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/CF1.cs	(revision 14825)
@@ -0,0 +1,51 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Problems.Instances.DataAnalysis {
+  public class CF1 : ResourceRegressionDataDescriptor {
+    public override string Name { get { return "CF1"; } }
+    public override string Description {
+      get {
+        return "Coefficient of friction, Publication: E. Lughofer, G. K. Kronberger, M. Kommenda, S. Saminger-Platz, " +
+               "A. Promberger, F. Nickel, S. M. Winkler, M. Affenzeller - Robust Fuzzy Modeling and Symbolic Regression " +
+               "for Establishing Accurate and Interpretable Prediction Models in Supervising Tribological Systems - " +
+               "Proceedings of the 8th International Joint Conference on Computational Intelligence, Porto, Portugal, 2016, pp. 51-63";
+      }
+    }
+    protected override string TargetVariable { get { return "Cf1"; } }
+    protected override string[] VariableNames {
+      get { return new string[] { "Partition", "Source1", "Source2", "x1", "Material_Cat", "x2", "x3", "x4", "x5", "x6", "x7", "x8", "x9", "x10", "x11", "x12", "x13", "x14", "x15", "x16", "Material", "Grooving", "Oil", "x17", "x18", "x19", "x20", "x21", "x22", "Cf1"
+ }; }
+    }
+
+    // TODO: include string variables after factor branch integration
+    protected override string[] AllowedInputVariables {
+      get { return new string[] { /* "Material_Cat", */
+        "x2", "x3", "x4", "x5", "x6", "x7", "x8", "x9", "x10", "x11", "x12", "x13", "x14", "x15", "x16",
+        /* "Material", "Grooving", "Oil", */                                           
+        "x17", "x20", "x22" }; }
+    }
+    protected override int TrainingPartitionStart { get { return 0; } }
+    protected override int TrainingPartitionEnd { get { return 611; } }
+    protected override int TestPartitionStart { get { return 611; } }
+    protected override int TestPartitionEnd { get { return 815; } }
+  }
+}
Index: branches/symbreg-factors-2650/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/CF2.cs
===================================================================
--- branches/symbreg-factors-2650/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/CF2.cs	(revision 14825)
+++ branches/symbreg-factors-2650/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/CF2.cs	(revision 14825)
@@ -0,0 +1,52 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Problems.Instances.DataAnalysis {
+  public class CF2 : ResourceRegressionDataDescriptor {
+    public override string Name { get { return "CF2"; } }
+    public override string Description {
+      get {
+        return "Coefficient of friction, Publication: E. Lughofer, G. K. Kronberger, M. Kommenda, S. Saminger-Platz, " +
+               "A. Promberger, F. Nickel, S. M. Winkler, M. Affenzeller - Robust Fuzzy Modeling and Symbolic Regression " +
+               "for Establishing Accurate and Interpretable Prediction Models in Supervising Tribological Systems - " +
+               "Proceedings of the 8th International Joint Conference on Computational Intelligence, Porto, Portugal, 2016, pp. 51-63";
+      }
+    }
+    protected override string TargetVariable { get { return "Cf2"; } }
+    protected override string[] VariableNames {
+      get { return new string[] { "Partition", "Source1", "Source2", "x1", "Material_Cat", "x2", "x3", "x4", "x5", "x6", "x7", "x8", "x9", "x10", "x11", "x12", "x13", "x14", "x15", "x16", "Material", "Grooving", "Oil", "x17", "x18", "x19", "x20", "x21", "x22", "Cf2"
+ };
+      }
+    }
+
+    // TODO: include string variables after factor branch integration
+    protected override string[] AllowedInputVariables {
+      get { return new string[] { /* "Material_Cat", */
+        "Source1", "Source2", "x1", "x2", "x3", "x4", "x5", "x6", "x7", "x8", "x9", "x10", "x11", "x12", "x13", "x14", "x15", "x16",
+        /* "Material", "Grooving", "Oil", */                                           
+        "x17", "x18", "x19", "x20", "x21", "x22" }; }
+    }
+    protected override int TrainingPartitionStart { get { return 0; } }
+    protected override int TrainingPartitionEnd { get { return 2196; } }
+    protected override int TestPartitionStart { get { return 2196; } }
+    protected override int TestPartitionEnd { get { return 2921; } }
+  }
+}
Index: branches/symbreg-factors-2650/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/CF3.cs
===================================================================
--- branches/symbreg-factors-2650/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/CF3.cs	(revision 14825)
+++ branches/symbreg-factors-2650/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/CF3.cs	(revision 14825)
@@ -0,0 +1,52 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Problems.Instances.DataAnalysis {
+  public class CF3 : ResourceRegressionDataDescriptor {
+    public override string Name { get { return "CF3"; } }
+    public override string Description {
+      get {
+        return "Coefficient of friction, Publication: E. Lughofer, G. K. Kronberger, M. Kommenda, S. Saminger-Platz, " +
+               "A. Promberger, F. Nickel, S. M. Winkler, M. Affenzeller - Robust Fuzzy Modeling and Symbolic Regression " +
+               "for Establishing Accurate and Interpretable Prediction Models in Supervising Tribological Systems - " +
+               "Proceedings of the 8th International Joint Conference on Computational Intelligence, Porto, Portugal, 2016, pp. 51-63";
+      }
+    }
+    protected override string TargetVariable { get { return "Cf3"; } }
+    protected override string[] VariableNames {
+      get { return new string[] { "Partition", "Source1", "Source2", "x1", "Material_Cat", "x2", "x3", "x4", "x5", "x6", "x7", "x8", "x9", "x10", "x11", "x12", "x13", "x14", "x15", "x16", "Material", "Grooving", "Oil", "x17", "x18", "x19", "x20", "x21", "x22", "Cf3"
+ };
+      }
+    }
+
+    // TODO: include string variables after factor branch integration
+    protected override string[] AllowedInputVariables {
+      get { return new string[] { /* "Material_Cat", */
+        /*"Source1", "Source2",*/ "x1", "x2", "x3", "x4", "x5", "x6", "x8", "x9", "x10", "x11", "x12", "x13", "x14", "x15", "x16",
+        /* "Material", "Grooving", "Oil", */                                           
+        "x17", "x22" }; }
+    }
+    protected override int TrainingPartitionStart { get { return 0; } }
+    protected override int TrainingPartitionEnd { get { return 441; } }
+    protected override int TestPartitionStart { get { return 441; } }
+    protected override int TestPartitionEnd { get { return 657; } }
+  }
+}
Index: branches/symbreg-factors-2650/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/CF4.cs
===================================================================
--- branches/symbreg-factors-2650/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/CF4.cs	(revision 14825)
+++ branches/symbreg-factors-2650/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/CF4.cs	(revision 14825)
@@ -0,0 +1,52 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Problems.Instances.DataAnalysis {
+  public class CF4 : ResourceRegressionDataDescriptor {
+    public override string Name { get { return "CF4"; } }
+    public override string Description {
+      get {
+        return "Coefficient of friction, Publication: E. Lughofer, G. K. Kronberger, M. Kommenda, S. Saminger-Platz, " +
+               "A. Promberger, F. Nickel, S. M. Winkler, M. Affenzeller - Robust Fuzzy Modeling and Symbolic Regression " +
+               "for Establishing Accurate and Interpretable Prediction Models in Supervising Tribological Systems - " +
+               "Proceedings of the 8th International Joint Conference on Computational Intelligence, Porto, Portugal, 2016, pp. 51-63";
+      }
+    }
+    protected override string TargetVariable { get { return "Cf4"; } }
+    protected override string[] VariableNames {
+      get { return new string[] { "Partition", "Source1", "Source2", "x1", "Material_Cat", "x2", "x3", "x4", "x5", "x6", "x7", "x8", "x9", "x10", "x11", "x12", "x13", "x14", "x15", "x16", "Material", "Grooving", "Oil", "x17", "x18", "x19", "x20", "x21", "x22", "Cf4"
+ };
+      }
+    }
+
+    // TODO: include string variables after factor branch integration
+    protected override string[] AllowedInputVariables {
+      get { return new string[] { /* "Material_Cat", */
+        "x1", "x2", "x3", "x4", "x5", "x6", "x8", "x9", "x10", "x11", "x12", "x13", "x14", "x15", "x16",
+        /* "Material", "Grooving", "Oil", */                                           
+        "x17", "x22" }; }
+    }
+    protected override int TrainingPartitionStart { get { return 0; } }
+    protected override int TrainingPartitionEnd { get { return 437; } }
+    protected override int TestPartitionStart { get { return 437; } }
+    protected override int TestPartitionEnd { get { return 649; } }
+  }
+}
Index: branches/symbreg-factors-2650/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/MibaFrictionRegressionInstanceProvider.cs
===================================================================
--- branches/symbreg-factors-2650/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/MibaFrictionRegressionInstanceProvider.cs	(revision 14825)
+++ branches/symbreg-factors-2650/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/MibaFrictionRegressionInstanceProvider.cs	(revision 14825)
@@ -0,0 +1,78 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.IO;
+using System.IO.Compression;
+using System.Linq;
+
+namespace HeuristicLab.Problems.Instances.DataAnalysis {
+  public class MibaFrictionRegressionInstanceProvider : ResourceRegressionInstanceProvider {
+    public override string Name {
+      get { return "Miba Friction Datasets"; }
+    }
+    public override string Description {
+      get {
+        return "A set of datasets for regression modelling of friction characteristics of friction plate systems. The data stem from tests of friction plates with commercial test benches for wet friction plate systems. Friction characteristics such as the coefficient of friction, wear, and temperatures are measured at different loads. The goal is to predict these values given load parameters. Data have been kindly provided by Miba frictec company";
+      }
+    }
+    public override Uri WebLink {
+      get { return null; }
+    }
+    public override string ReferencePublication {
+      get { return "E. Lughofer, G. K. Kronberger, M. Kommenda, S. Saminger-Platz, A. Promberger, F. Nickel, S. M. Winkler, M. Affenzeller - Robust Fuzzy Modeling and Symbolic Regression for Establishing Accurate and Interpretable Prediction Models in Supervising Tribological Systems - Proceedings of the 8th International Joint Conference on Computational Intelligence, Porto, Portugal, 2016, pp. 51-63"; }
+    }
+
+    protected override string FileName { get { return "MibaFriction"; } }
+
+    public override IEnumerable<IDataDescriptor> GetDataDescriptors() {
+      List<ResourceRegressionDataDescriptor> descriptorList = new List<ResourceRegressionDataDescriptor>();
+      descriptorList.Add(new CF1());
+      descriptorList.Add(new CF2());
+      descriptorList.Add(new CF3());
+      descriptorList.Add(new CF4());
+      descriptorList.Add(new NvhRating());
+      descriptorList.Add(new Temp1());
+      descriptorList.Add(new Temp2());
+      descriptorList.Add(new Wear1());
+      descriptorList.Add(new Wear2());
+      var solutionsArchiveName = GetResourceName(FileName + @"\.zip");
+      if (!String.IsNullOrEmpty(solutionsArchiveName)) {
+        using (var solutionsZipFile = new ZipArchive(GetType().Assembly.GetManifestResourceStream(solutionsArchiveName), ZipArchiveMode.Read)) {
+          IList<string> entries = new List<string>();
+          foreach (var curEntry in solutionsZipFile.Entries) {
+            entries.Add(curEntry.Name);
+          }
+          foreach (var entry in entries.OrderBy(x => x)) {
+            string prettyName = Path.GetFileNameWithoutExtension(entry);
+            ResourceRegressionDataDescriptor desc = descriptorList.Where(x => x.Name.Equals(prettyName)).FirstOrDefault();
+            if (desc != null) {
+              desc.ResourceName = entry;
+              yield return desc;
+            } else
+              throw new ArgumentNullException("No descriptor could be found for this entry.");
+          }
+        }
+      }
+    }
+  }
+}
Index: branches/symbreg-factors-2650/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/NvhRating.cs
===================================================================
--- branches/symbreg-factors-2650/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/NvhRating.cs	(revision 14825)
+++ branches/symbreg-factors-2650/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/NvhRating.cs	(revision 14825)
@@ -0,0 +1,52 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Problems.Instances.DataAnalysis {
+  public class NvhRating : ResourceRegressionDataDescriptor {
+    public override string Name { get { return "NvhRating"; } }
+    public override string Description {
+      get {
+        return "Noise-vibration-harshness rating (1..8), Publication: E. Lughofer, G. K. Kronberger, M. Kommenda, S. Saminger-Platz, " +
+               "A. Promberger, F. Nickel, S. M. Winkler, M. Affenzeller - Robust Fuzzy Modeling and Symbolic Regression " +
+               "for Establishing Accurate and Interpretable Prediction Models in Supervising Tribological Systems - " +
+               "Proceedings of the 8th International Joint Conference on Computational Intelligence, Porto, Portugal, 2016, pp. 51-63";
+      }
+    }
+    protected override string TargetVariable { get { return "NVH_Rating"; } }
+    protected override string[] VariableNames {
+      get { return new string[] { "Partition", "Source1", "Source2", "x1", "Material_Cat", "x2", "x3", "x4", "x5", "x6", "x7", "x8", "x9", "x10", "x11", "x12", "x13", "x14", "x15", "x16", "Material", "Grooving", "Oil", "x17", "x18", "x19", "x20", "x21", "x22", "NVH_Rating"
+ };
+      }
+    }
+
+    // TODO: include string variables after factor branch integration
+    protected override string[] AllowedInputVariables {
+      get { return new string[] { /* "Material_Cat", */
+        "x1", "x2", "x3", "x4", "x5", "x6", "x8", "x9", "x10", "x11", "x12", "x13", "x14", "x15", "x16",
+        /* "Material", "Grooving", "Oil", */                                           
+        "x17", "x18", "x19", "x21", "x22" }; }
+    }
+    protected override int TrainingPartitionStart { get { return 0; } }
+    protected override int TrainingPartitionEnd { get { return 2636; } }
+    protected override int TestPartitionStart { get { return 2636; } }
+    protected override int TestPartitionEnd { get { return 3943; } }
+  }
+}
Index: branches/symbreg-factors-2650/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Temp1.cs
===================================================================
--- branches/symbreg-factors-2650/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Temp1.cs	(revision 14825)
+++ branches/symbreg-factors-2650/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Temp1.cs	(revision 14825)
@@ -0,0 +1,52 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Problems.Instances.DataAnalysis {
+  public class Temp1 : ResourceRegressionDataDescriptor {
+    public override string Name { get { return "Temp1"; } }
+    public override string Description {
+      get {
+        return "Temperature, Publication: E. Lughofer, G. K. Kronberger, M. Kommenda, S. Saminger-Platz, " +
+               "A. Promberger, F. Nickel, S. M. Winkler, M. Affenzeller - Robust Fuzzy Modeling and Symbolic Regression " +
+               "for Establishing Accurate and Interpretable Prediction Models in Supervising Tribological Systems - " +
+               "Proceedings of the 8th International Joint Conference on Computational Intelligence, Porto, Portugal, 2016, pp. 51-63";
+      }
+    }
+    protected override string TargetVariable { get { return "Temp1"; } }
+    protected override string[] VariableNames {
+      get { return new string[] { "Partition", "Source1", "Source2", "x1", "Material_Cat", "x2", "x3", "x4", "x5", "x6", "x7", "x8", "x9", "x10", "x11", "x12", "x13", "x14", "x15", "x16", "Material", "Grooving", "Oil", "x17", "x18", "x19", "x20", "x21", "x22", "Temp1"
+ };
+      }
+    }
+
+    // TODO: include string variables after factor branch integration
+    protected override string[] AllowedInputVariables {
+      get { return new string[] { /* "Material_Cat", */
+        "x1", "x2", "x3", "x4", "x5", "x6", "x8", "x9", "x10", "x11", "x12", "x13", "x14", "x15", "x16",
+        /* "Material", "Grooving", "Oil", */                                           
+        "x17", "x22" }; }
+    }
+    protected override int TrainingPartitionStart { get { return 0; } }
+    protected override int TrainingPartitionEnd { get { return 440; } }
+    protected override int TestPartitionStart { get { return 440; } }
+    protected override int TestPartitionEnd { get { return 656; } }
+  }
+}
Index: branches/symbreg-factors-2650/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Temp2.cs
===================================================================
--- branches/symbreg-factors-2650/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Temp2.cs	(revision 14825)
+++ branches/symbreg-factors-2650/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Temp2.cs	(revision 14825)
@@ -0,0 +1,52 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Problems.Instances.DataAnalysis {
+  public class Temp2 : ResourceRegressionDataDescriptor {
+    public override string Name { get { return "Temp2"; } }
+    public override string Description {
+      get {
+        return "Temperature, Publication: E. Lughofer, G. K. Kronberger, M. Kommenda, S. Saminger-Platz, " +
+               "A. Promberger, F. Nickel, S. M. Winkler, M. Affenzeller - Robust Fuzzy Modeling and Symbolic Regression " +
+               "for Establishing Accurate and Interpretable Prediction Models in Supervising Tribological Systems - " +
+               "Proceedings of the 8th International Joint Conference on Computational Intelligence, Porto, Portugal, 2016, pp. 51-63";
+      }
+    }
+    protected override string TargetVariable { get { return "Temp2"; } }
+    protected override string[] VariableNames {
+      get { return new string[] { "Partition", "Source1", "Source2", "x1", "Material_Cat", "x2", "x3", "x4", "x5", "x6", "x7", "x8", "x9", "x10", "x11", "x12", "x13", "x14", "x15", "x16", "Material", "Grooving", "Oil", "x17", "x18", "x19", "x20", "x21", "x22", "Temp2"
+ };
+      }
+    }
+
+    // TODO: include string variables after factor branch integration
+    protected override string[] AllowedInputVariables {
+      get { return new string[] { /* "Material_Cat", */
+        "x1", "x2", "x3", "x4", "x5", "x6", "x8", "x9", "x10", "x11", "x12", "x13", "x14", "x15", "x16",
+        /* "Material", "Grooving", "Oil", */                                           
+        "x17", "x22" }; }
+    }
+    protected override int TrainingPartitionStart { get { return 0; } }
+    protected override int TrainingPartitionEnd { get { return 437; } }
+    protected override int TestPartitionStart { get { return 437; } }
+    protected override int TestPartitionEnd { get { return 648; } }
+  }
+}
Index: branches/symbreg-factors-2650/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Wear1.cs
===================================================================
--- branches/symbreg-factors-2650/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Wear1.cs	(revision 14825)
+++ branches/symbreg-factors-2650/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Wear1.cs	(revision 14825)
@@ -0,0 +1,52 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Problems.Instances.DataAnalysis {
+  public class Wear1 : ResourceRegressionDataDescriptor {
+    public override string Name { get { return "Wear1"; } }
+    public override string Description {
+      get {
+        return "Wear, Publication: E. Lughofer, G. K. Kronberger, M. Kommenda, S. Saminger-Platz, " +
+               "A. Promberger, F. Nickel, S. M. Winkler, M. Affenzeller - Robust Fuzzy Modeling and Symbolic Regression " +
+               "for Establishing Accurate and Interpretable Prediction Models in Supervising Tribological Systems - " +
+               "Proceedings of the 8th International Joint Conference on Computational Intelligence, Porto, Portugal, 2016, pp. 51-63";
+      }
+    }
+    protected override string TargetVariable { get { return "Wear1"; } }
+    protected override string[] VariableNames {
+      get { return new string[] { "Partition", "Source1", "Source2", "x1", "Material_Cat", "x2", "x3", "x4", "x5", "x6", "x7", "x8", "x9", "x10", "x11", "x12", "x13", "x14", "x15", "x16", "Material", "Grooving", "Oil", "x17", "x18", "x19", "x20", "x21", "x22", "Wear1"
+ };
+      }
+    }
+
+    // TODO: include string variables after factor branch integration
+    protected override string[] AllowedInputVariables {
+      get { return new string[] { /* "Material_Cat", */
+        "Source1", "x1", "x2", "x3", "x4", "x5", "x6", "x7", "x8", "x9", "x10", "x11", "x12", "x13", "x14", "x15", "x16",
+        /* "Material", "Grooving", "Oil", */                                           
+        "x17", "x18", "x19", "x20", "x21", "x22" }; }
+    }
+    protected override int TrainingPartitionStart { get { return 0; } }
+    protected override int TrainingPartitionEnd { get { return 641; } }
+    protected override int TestPartitionStart { get { return 641; } }
+    protected override int TestPartitionEnd { get { return 904; } }
+  }
+}
Index: branches/symbreg-factors-2650/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Wear2.cs
===================================================================
--- branches/symbreg-factors-2650/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Wear2.cs	(revision 14825)
+++ branches/symbreg-factors-2650/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Wear2.cs	(revision 14825)
@@ -0,0 +1,52 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Problems.Instances.DataAnalysis {
+  public class Wear2 : ResourceRegressionDataDescriptor {
+    public override string Name { get { return "Wear2"; } }
+    public override string Description {
+      get {
+        return "Wear, Publication: E. Lughofer, G. K. Kronberger, M. Kommenda, S. Saminger-Platz, " +
+               "A. Promberger, F. Nickel, S. M. Winkler, M. Affenzeller - Robust Fuzzy Modeling and Symbolic Regression " +
+               "for Establishing Accurate and Interpretable Prediction Models in Supervising Tribological Systems - " +
+               "Proceedings of the 8th International Joint Conference on Computational Intelligence, Porto, Portugal, 2016, pp. 51-63";
+      }
+    }
+    protected override string TargetVariable { get { return "Wear2"; } }
+    protected override string[] VariableNames {
+      get { return new string[] { "Partition", "Source1", "Source2", "x1", "Material_Cat", "x2", "x3", "x4", "x5", "x6", "x7", "x8", "x9", "x10", "x11", "x12", "x13", "x14", "x15", "x16", "Material", "Grooving", "Oil", "x17", "x18", "x19", "x20", "x21", "x22", "Wear2"
+ };
+      }
+    }
+
+    // TODO: include string variables after factor branch integration
+    protected override string[] AllowedInputVariables {
+      get { return new string[] { /* "Material_Cat", */
+        "Source1", "x1", "x2", "x3", "x4", "x5", "x6", "x7", "x8", "x9", "x10", "x11", "x12", "x13", "x14", "x15", "x16",
+        /* "Material", "Grooving", "Oil", */                                           
+        "x17", "x18", "x19", "x20", "x21", "x22" }; }
+    }
+    protected override int TrainingPartitionStart { get { return 0; } }
+    protected override int TrainingPartitionEnd { get { return 640; } }
+    protected override int TestPartitionStart { get { return 640; } }
+    protected override int TestPartitionEnd { get { return 902; } }
+  }
+}